Last Comment Bug 255050 - When saving a draft, progress dialog box title first says "Sending messages" and then sometimes changes to "Saving messages -"
: When saving a draft, progress dialog box title first says "Sending messages" ...
Status: RESOLVED FIXED
: ux-userfeedback
Product: MailNews Core
Classification: Components
Component: Composition (show other bugs)
: Trunk
: All All
: -- minor with 3 votes (vote)
: Thunderbird 17.0
Assigned To: :aceman
:
Mentors:
: 594042 647681 774172 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2004-08-10 10:53 PDT by David Grant
Modified: 2012-09-24 07:38 PDT (History)
14 users (show)
ryanvm: in‑testsuite-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
patch (11.68 KB, patch)
2012-07-18 12:52 PDT, :aceman
iann_bugzilla: review+
bwinton: ui‑review+
Details | Diff | Review
patch v2 (12.04 KB, patch)
2012-07-23 13:44 PDT, :aceman
mkmelin+mozilla: review+
Details | Diff | Review
patch v3 (12.03 KB, patch)
2012-07-28 12:02 PDT, :aceman
acelists: review+
iann_bugzilla: review+
Details | Diff | Review

Description David Grant 2004-08-10 10:53:13 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.7) Gecko/20040707 Webemu/0.9.2 (All your Firefox/0.9.2 are belong to Firesomething)
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.7) Gecko/20040707 Webemu/0.9.2 (All your Firefox/0.9.2 are belong to Firesomething)

Save a draft, then a window appears briefly and the title of that window says
"Sending Messages..." then it changes to "Saving Messages" or something like
that.  I think it helps if your draft is large, then the little dialog is open
long enough so that you can read it.

Reproducible: Always
Steps to Reproduce:
1. Save a draft, a large one
2. Notice the pop-up dialog window title says "Sending Messages..."
3. Get scared.

Actual Results:  
Notice the pop-up dialog window title says "Sending Messages..."

Expected Results:  
It shouldn't say "Sending Messages..."
Comment 1 James Davis 2004-08-11 07:01:12 PDT
My eyes aren't fast enough to be 100% sure but I think I can see this under 
0.7+ (20040810).
Comment 2 Lorenzo Colitti 2004-08-17 16:53:07 PDT
I see this too. It'easier to see if you have a slow IMAP server.

Confirming, setting severity to minor.
Comment 3 Ben 2004-09-23 23:30:46 PDT
Confirmed on TB 0.8, W2000pro with local folders.

There is a related bug that says it was fixed in 2001, but apparently it either
came back or didn't make it into TB: #86398.
Comment 4 Iavor Raytchev 2005-08-24 13:23:05 PDT
Perhaps related problem - on my nightly build (a couple of weeks old) very often
upon attempt to save draft it says CAN NOT SAVE MESSAGE IN SENT ITEMS FOLDER.
Seems something is messed up here.
Comment 5 Ben 2005-12-28 07:41:47 PST
It is still there in Thunderbird version 1.0.7. It can be really annoying, because the user gets the impression that she/he hit the wrong button.
Comment 6 David Fraser 2007-04-23 02:33:32 PDT
It's not just the status bar message - there is also dialog boxes that pop up to say that the encoding has problems (and asks you what to Send the message as whereas its really only saving it) or to say there was an error sending (as opposed to saving)
This still happens in 2.0.0.0
Comment 7 Mark Banner (:standard8) 2012-02-06 05:17:19 PST
*** Bug 594042 has been marked as a duplicate of this bug. ***
Comment 8 Wayne Mery (:wsmwk, NI for questions) 2012-04-08 09:51:50 PDT
Ben using version 6 wrote:
"However large the email body or attachments, the dialog box only appears during a fraction of a second and I cannot read the title. "
Comment 9 WBT 2012-04-09 07:44:29 PDT
Well Ben using version 6 must have a fast computer, network connection, and IMAP server and never have any issues in the connection.  I still see this as a daily annoyance triggering a wave of concern every time I see "failed to send message," "sending message," "Thunderbird is in the process of sending a message," etc. when I'm saving a draft that's not ready to be sent.  This seems to be a copy/paste error in the code, either with a string, string name, or function call.
This bug, the fact that it has been around since 2004 and still is not fixed, and my experience trying to address it remain as a unit the single greatest reason why I don't recommend Thunderbird.  That kind of error would be OK for research-grade software where most users are developers, but not in something ready for prime time.  A spelling or grammar error, OK; but "sending" instead of "saving draft" is qualitatively a different action.  Getting it wrong (in either direction) can have significant consequences for the sender, and the negative consequences (when the sender knows that they exist) are first felt when you first see the software indicate the wrong one.
Comment 10 David :Bienvenu 2012-04-09 08:11:10 PDT
if it's not obvious, the reason the messages are wrong is because the code that saves drafts and the code that copies to the sent folder is shared code, not a copy paste error.
Comment 11 WBT 2012-06-30 12:22:50 PDT
Duplicate of Bug 257735?
Comment 12 :aceman 2012-07-18 07:53:36 PDT
OK, I see it now too. The title flashes as "Sending messages" and then changes to "Saving messages -" (even with the dash). On slow machines (disk I/O, low RAM) it could be visible for a second.

The problem seems to be this:
The dialog is initialized here http://mxr.mozilla.org/comm-central/source/mailnews/compose/content/sendProgress.xul with the title set to be "Sending Messages". Then only once it loads it determines if it is actually sending or saving and sets the proper title (the code here http://mxr.mozilla.org/comm-central/source/mailnews/compose/content/sendProgress.js#135).

Maybe the setting operation is sometimes too slow.
I am not sure I can move it any sooner in the code flow. But at least we could either:
1. set the initial dialog title to something neutral, e.g. "preparing operation"
2. or let the initial title be blank until the proper string is determined.
Bwinton?
Comment 13 :aceman 2012-07-18 07:55:51 PDT
*** Bug 647681 has been marked as a duplicate of this bug. ***
Comment 14 :aceman 2012-07-18 08:05:19 PDT
While there maybe the strings could be fixed up a bit better.
http://mxr.mozilla.org/comm-central/source/mail/locales/en-US/chrome/messenger/messengercompose/sendProgress.properties

The title is in plural, but the final status message (messageSent) is in singular. Can there really be multiple messages in progress while this dialog is up?

Then, the title concatenates the Save/Send string with the message subject. This could be made properly localizable, like "Sending Messages - %S".
Comment 15 :aceman 2012-07-18 08:15:35 PDT
When I have simple email with a big attachment, the title reflashes to the correct string immediately.
When I have a large HTML email, the string is bad for a long time (and the dialog is empty) and only reflashes at the end.

It may be that in some cases the onLoad() method of the dialog does not get to execute soon enough. Maybe other code (msg parser) runs sooner and starves the dialog.
Comment 16 :aceman 2012-07-18 12:52:32 PDT
Created attachment 643531 [details] [diff] [review]
patch

So this is my proposal. Is it better?
Comment 17 :aceman 2012-07-18 12:53:09 PDT
Oh, I should probably change the stringIDs in the .properties file too...
Comment 18 Ian Neal 2012-07-21 15:29:13 PDT
Comment on attachment 643531 [details] [diff] [review]
patch

As you said, need to change the entity names. I couldn't see the initial title no matter what size draft I tried to save though.
r=me with entity names changed
Comment 19 Blake Winton (:bwinton) (:☕️) (PTO 'til London. Find me there for quick answers!) 2012-07-23 12:39:42 PDT
Comment on attachment 643531 [details] [diff] [review]
patch

I like it.  I think it would be nice to have a message with an empty subject say "Saving Message" instead of "Saving Message - ", but you get the ui-r=me even if you don't make that change.

Thanks,
Blake.
Comment 20 :aceman 2012-07-23 13:44:19 PDT
Created attachment 645051 [details] [diff] [review]
patch v2

Ok, added.
Comment 21 Magnus Melin 2012-07-28 11:35:07 PDT
Comment on attachment 645051 [details] [diff] [review]
patch v2

Review of attachment 645051 [details] [diff] [review]:
-----------------------------------------------------------------

Thx for the patch! r=mkmelin

::: mailnews/compose/content/sendProgress.js
@@ +124,5 @@
>          subject = progressParams.subject;
>        }
>      }
>  
> +    let prefix = itsASaveOperation ? "titlePrefixSaveMsg" : "titlePrefixSendMsg";

I know this is copied, but i would not form the localization keys on the fly, it makes them hard to find and otherwise error prone. Just assign the full key name where you need it.
Comment 22 :aceman 2012-07-28 12:02:39 PDT
Created attachment 646885 [details] [diff] [review]
patch v3

Thanks!
Comment 23 Magnus Melin 2012-07-28 12:05:48 PDT
Should probably have some suite people look at it too as it's suite/ too
Comment 24 :aceman 2012-07-28 12:07:27 PDT
I've got r+ from IanN in comment 18. Do you mean there are some new important changes that he didn't see?
Comment 25 Ian Neal 2012-07-28 12:39:55 PDT
Comment on attachment 646885 [details] [diff] [review]
patch v3

To make everyone happy r=me
Comment 26 Magnus Melin 2012-07-29 13:23:02 PDT
Ah, no, just didn't notice it in the comments
Comment 27 Ryan VanderMeulen [:RyanVM] 2012-07-29 15:34:29 PDT
https://hg.mozilla.org/comm-central/rev/1d9804d82741
Comment 28 :aceman 2012-09-24 07:38:14 PDT
*** Bug 774172 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.